export declare type SlotType<T> = (value: T) => Slot<T>;
export declare class Slot<T = any> {
    type: any;
    value: T;
    constructor(/* @internal */ type: any, value: T);
    static define<T>(): SlotType<T>;
    static get<T>(type: SlotType<T>, slots: ReadonlyArray<Slot>): T | undefined;
}
declare const enum Kind {
    Behavior = 0,
    Multi = 1,
    Unique = 2
}
export declare type Behavior<Value> = (value: Value) => Extension;
export declare class Extension {
    kind: Kind;
    id: any;
    value: any;
    priority: number;
    constructor(/* @internal */ kind: Kind, id: any, value: any, priority?: number);
    private setPrio;
    fallback(): this;
    extend(): this;
    override(): this;
    flatten(priority: number, target?: Extension[]): Extension[];
    collect(array: Extension[]): void;
    static defineBehavior<Value>(): Behavior<Value>;
    static unique<Spec>(instantiate: (specs: Spec[]) => Extension, defaultSpec?: Spec): (spec?: Spec) => Extension;
    static all(...extensions: Extension[]): Extension;
    static resolve(extensions: ReadonlyArray<Extension>): BehaviorStore;
}
export declare class BehaviorStore {
    behaviors: any[];
    values: any[][];
    foreign: Extension[];
    get<Value>(behavior: Behavior<Value>): Value[];
}
declare type NonUndefined<T> = T extends undefined ? never : T;
export declare type Full<T> = {
    [K in keyof T]-?: T[K];
};
export declare function combineConfig<Config>(configs: ReadonlyArray<Config>, defaults: Partial<Config>, // Should hold only the optional properties of Config, but I haven't managed to express that
combine?: {
    [P in keyof Config]?: (first: NonUndefined<Config[P]>, second: NonUndefined<Config[P]>) => NonUndefined<Config[P]>;
}): Full<Config>;
export declare function fillConfig<Config>(config: Config, defaults: Partial<Config>): Full<Config>;
export {};
